VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   420
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4545
   LinkTopic       =   "Form1"
   ScaleHeight     =   420
   ScaleWidth      =   4545
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdEject 
      Caption         =   "Eject removalble drive"
      Height          =   345
      Left            =   2370
      TabIndex        =   1
      Top             =   30
      Width           =   2145
   End
   Begin VB.ComboBox cbDrive 
      Height          =   315
      Left            =   30
      TabIndex        =   0
      Top             =   30
      Width           =   2295
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' ----==== KERNEL32 Deklarationen ====----
Private Declare Function GetLogicalDrives Lib "kernel32" () As Long

Private Sub cmdEject_Click()

    Dim strDriveLetter As String
    
    ' sind Eintrge in der ComboBox vorhanden
    If cbDrive.ListCount > 0 Then
    
        ' Laufwerksbuchstaben auslesen
        strDriveLetter = Chr$(65 + cbDrive.ItemData(cbDrive.ListIndex))
        
        ' Laufwerk auswerfen
        If EjectUsbDrive(strDriveLetter, True) Then
        
            MsgBox "Laufwerk '" & strDriveLetter & ":\' wurde " & _
                "erfolgreich enfernt.", vbOKOnly Or vbInformation
                
            ' alle auswerfbare Laufwerke ermitteln
            Call ListRemovableDrives
                
        Else
        
            MsgBox "Laufwerk '" & strDriveLetter & ":\' konnte nicht " & _
                "enfernt werden.", vbOKOnly Or vbExclamation
                
        End If
    End If
    
End Sub

Private Sub ListRemovableDrives()

    Dim lngDriveNum As Long
    Dim lngRet As Long
    Dim strDriveName As String
    
    ' Button deaktivieren
    cmdEject.Enabled = False
    
    ' alle Items in der ListBox lschen
    cbDrive.Clear
    
    ' alle verfgbare Laufwerke ermitteln
    lngRet = GetLogicalDrives
    
    ' alle Laufwerksnummern durchlaufen
    For lngDriveNum = 0 To 25
    
        ' ist das entsprechende Bit in lngRet <> 0
        If (lngRet And 2 ^ lngDriveNum) <> 0 Then
        
            ' Laufwerksbuchstabe
            strDriveName = Chr$(65 + lngDriveNum)
            
                ' Laufwerkstyp ermitteln (USB-Laufwerke)
                If Len(GetDevInstStr(strDriveName)) > 0 Then
                
                    ' Daten in der ComboBox ausgeben und speichern
                    cbDrive.AddItem strDriveName & ":\"
                    cbDrive.ItemData(cbDrive.NewIndex) = lngDriveNum
                    
                End If
        End If
        
        ' nchste Laufwerksnummer
    Next lngDriveNum
    
    ' sind Eintrge in der ComboBox vorhanden
    If cbDrive.ListCount > 0 Then
    
        ' erster Eintrag in der ComboBox
        cbDrive.ListIndex = 0
        
        ' Button aktivieren
        cmdEject.Enabled = True
        
    End If

End Sub

Private Sub Form_Load()

    ' alle auswerfbare Laufwerke ermitteln
    Call ListRemovableDrives
    
End Sub
